unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, FPimage, IntfGraphics,
  StdCtrls, ExtCtrls, LCLIntf, GraphType;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    BitTextur: TBitmap;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
 Timer1.Enabled:= true;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 Timer1.Enabled:= false;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  Canvas.Draw(0, 0, BitTextur);
  if assigned(BitTextur) then FreeAndNil(BitTextur);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
const
    ASize    = 500;
var x, y     : integer;
    aColor   : TColor;
    aFPColor : TFPColor;
    AImage   : TLazIntfImage;
    ARawImage: TRawImage;

begin
 if assigned(BitTextur) then exit;
 BitTextur := TBitmap.Create;
 ARawImage.Init;
 ARawImage.Description.Init_BPP32_B8G8R8A8_BIO_TTB(ASize, ASize);
 ARawImage.CreateData(True);
 AImage := TLazIntfImage.Create(0, 0);
 AImage.SetRawImage(ARawImage);

 for y := 0 to AImage.Height - 1 do
  begin
    for x := 0 to AImage.Width - 1 do
     begin
      aColor := RGB(Random(255),Random(255),Random(255));
      aFPColor := TColorToFPColor(aColor);
      AImage.Colors[x, y] := aFPColor;
     end;
  end;

 BitTextur.LoadFromIntfImage(AImage);
 Invalidate;
 AImage.Free;
end;


end.

